require('avalon', function(avalon) {
	var $=function(id){
		return document.getElementById(id);
	};
	function po_Last_Div(obj) {
		if (window.getSelection) {
			obj.focus();
			var range = window.getSelection();
			range.selectAllChildren(obj);
			range.collapseToEnd();
		}
		else if (document.selection) {
			var range = document.selection.createRange();
			range.moveToElementText(obj);
			range.collapse(false);
			range.select();
		}
	}
	function getTextBeforeCursor(containerEl) {
		var precedingChar = "", sel, range, precedingRange;
		if (window.getSelection) {
			sel = window.getSelection();
			if (sel.rangeCount > 0) {
				range = sel.getRangeAt(0).cloneRange();
				range.collapse(true);
				range.setStart(containerEl, 0);
				precedingChar = range.cloneContents();
			}
		} else if ( (sel = document.selection)) {
			range = sel.createRange();
			precedingRange = range.duplicate();
			precedingRange.moveToElementText(containerEl);
			precedingRange.setEndPoint("EndToStart", range);
			precedingChar = precedingRange.htmlText;
		}
		return precedingChar;
	}
	function at_box_show(at){
		var at_pos=avalon($(at)).position();
		$('at_box').style.left=at_pos.left+'px';
		$('at_box').style.top=at_pos.top+16+'px';
		$('at_box').style.display='block';
	}
	var at_index=0,cur_index=0;
	avalon.define('editor', function(vm) {
		vm.item_click=function(){
			$('at'+cur_index).innerHTML="@"+this.innerHTML;
			$('at_box').style.display='none';
			at_index++;
		};
		vm.check_key=function(e){
			var editor=$('editor'),a=getTextBeforeCursor(editor),range;
			if(e.shiftKey&&e.keyCode==50){
				if (document.selection && document.selection.createRange) {
					range = document.selection.createRange();
					range.pasteHTML("&nbsp;<span id='at"+at_index+"' class='at_span'>@</span>&nbsp;");
				}else{
					document.execCommand("insertHtml", false,"&nbsp;<span id='at"+at_index+"' class='at_span'>@</span>&nbsp;");
				}
				at_box_show('at'+at_index);
				po_Last_Div($('at'+at_index));
				cur_index=at_index;
				e.preventDefault();
			}
			if(e.keyCode==8){
				if(!-[1,]){
					var b=avalon.parseHTML(a).lastChild;
				}else{
					var b=a.lastChild;
				}
				if(b.nodeType==1&&b.nodeName=='SPAN'){
					var id=b.id;
					cur_index=b.id.substring(2);
					at_box_show(b.id);
				}else
					$('at_box').style.display='none';
			}
		};
		vm.check_mouse=function(e){
			var editor=$('editor'),a=getTextBeforeCursor(editor);
			if(!-[1,]){
				var b=avalon.parseHTML(getTextBeforeCursor(editor)).lastChild;

			}else{
				var b=a.lastChild;
			}
			if(b!=null&&b.nodeType==1&&b.nodeName=='SPAN'){
				var id=b.id;
				cur_index=b.id.substring(2);
				at_box_show(b.id);
			}else
				$('at_box').style.display='none';
		};
	});
	avalon.scan();
});